---
layout: post
comments: true
title: "Don't use DCC & How to disable it"
category: [english]
tags: [irc, english]
redirect_from: /english/2015/03/18/nodcc.html
---

DCC was way to send files and chat without having IRC server in the
between. It's not very common nowadays and what is done nowadays is
uploading images etc. to social media services or web servers or using
other file transfer protocols.

Here are some reasons to not use it:

* There is no proper standard or if there is, no one follows it, all
  clients speak their own dialects and may be unable to communicate with
  other clients. Not all clients even implement the same features.
* NAT and firewalls break it
    * As DCC requires port on sending/hosting side, it must be opened in
      firewall and if there is NAT which there is in most of situations
      nowadays, the port must be forwarded. Most of average users have
      no idea how to do the latter if even the first.
* The only place where most of people see it is spam. The only thing lately
  where people have seen is two attacks which @grawity has documented
  [here](https://nullroute.eu.org/~grawity/dcc.html)

## Disabling DCC

This depends on your client and I am only able to give instructions for
three:

* WeeChat: "`/plugin unload xfer`" and "`/set weechat.plugin.autoload *,!xfer`"
    * The option in second command can be also be used to not automatically
      load other plugins, I personally use `/set weechat.plugin.autoload alias,exec,irc,perl,python,script,trigger,logger`.
      The `*,!xfer` simply means load everything else than xfer.
* HexChat: "`/ignore *!*@* DCC`"
* ZNC & clients behind it: "`/znc *controlpanel addctcp $me DCC`"
